#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "cmds.h"

#include "3d.h"
#include "camera.h"
#include "message.h"
#include "quest.h"
#include "times.h"


static void C_debug_dump_messages(void)
{
   DumpMessages();
   NewMessage("Messages dumped to message.out.");
}


static void Profile(int vport)
{
   int i;
   int old_vp;

   old_vp=M.display.active_vport;
   M.display.active_vport=vport;
   for (i=0;i<100;i++)
   {
      MoveCamera(M.display.active_vport,MOVE_FORWARD);
      UpdateViewport(M.display.active_vport,TRUE);
   }
   M.display.active_vport=old_vp;
}

#define Time(x) \
({ \
   float start; \
   float end; \
    \
   start=GetTime(); \
   x; \
   end=GetTime(); \
   printf("--- start=%-5.3f end=%-5.3f elap=%-5.3f %s ---\n",start,end,end-start,#x); \
})

static void C_debug_profile(void)
{
   Time(Profile(0));
   Time(Profile(1));
   Time(Profile(2));
}


static cmd_reg_t debug_cmds[]={
{"debug_dump_messages",C_debug_dump_messages,"Dump all messages in memory."},
{"debug_profile",C_debug_profile,"Profile the renderer, draw 100 frames in three viewports."},
};

static void RegCmds(void) __attribute__ ((constructor));
static void RegCmds(void)
{
   Cmd_Register(debug_cmds,sizeof(debug_cmds));
}

