/*
camera.h file of the Quest Source Code

Copyright 1997, 1998 Alexander Malmberg
Copyright 1996, Trey Harrison and Chris Carollo

This program is distributed under the GNU General Public License.
See legal.txt for more information.
*/

#ifndef CAMERA_H
#define CAMERA_H

struct viewport_s;
void GetRotValues(struct viewport_s *v,float *rx,float *ry,float *rz);

void Move  (struct viewport_s *v,int dir, vec3_t *d, int amt);
void Move90(struct viewport_s *v,int dir, vec3_t *d, int amt);
void MoveCamera(struct viewport_s *v,int dir);

void Cam_LookDown(void);
void Cam_LookUp(void);
void Cam_TurnLeft(void);
void Cam_TurnRight(void);
void Cam_RollLeft(void);
void Cam_RollRight(void);

void AutoZoom(vec3_t w);


void InitViewport(struct viewport_s *v);
void InitViewports(void);

#endif

