#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "game.h"
#include "game_reg.h"

#include "s_error.h"


static game_reg_t *G;


int G_LoadMap(const char *fname)
{
   if (!G)
   {
      S_Error("G_LoadMap","No game active!");
      return 1;
   }
   if (!G->map.load)
   {
      S_Error("G_LoadMap","The active game doesn't provide a map loader!");
      return 1;
   }
   return G->map.load(fname);
}

int G_SaveMap(const char *fname)
{
   if (!G)
   {
      S_Error("G_SaveMap","No game active!");
      return 1;
   }
   if (!G->map.save)
   {
      S_Error("G_SaveMap","The active game doesn't provide a map saver!");
      return 1;
   }
   return G->map.save(fname);
}


int G_Texdef_Init(struct texdef_s *t)
{
   if (G->texdef.init) return G->texdef.init(t);
   return 1;
}

void G_Texdef_Free(struct texdef_s *t)
{
   if (G->texdef.free) G->texdef.free(t);
}

int G_Texdef_Copy(struct texdef_s *dst,const struct texdef_s *src)
{
   if (G->texdef.copy) return G->texdef.copy(dst,src);
   return 1;
}


int G_Load(game_reg_t *g)
{
   if (G) return 0;
   G=g;
   return 1;
}

void G_Unload(void)
{
   G=NULL;
}

