#ifndef GL__GL_REND_H
#define GL__GL_REND_H


typedef struct
{
   viewport_t vp;
   
   int sx,sy;
   matrix_t m;

   int mode;
#define M_WIRE      0x01
#define M_TEXTURE   0x02
#define M_FLAT      0x03

#define M_MAX_MODE  0x04

#define M_MODE      0x0f
   
#define M_2D          0x10
#define M_2D_WIRE     (M_2D+M_WIRE)
#define M_2D_TEXTURE  (M_2D+M_TEXTURE)
#define M_2D_FLAT     (M_2D+M_FLAT)

#define M_3D          0x20
#define M_3D_WIRE     (M_3D+M_WIRE)
#define M_3D_TEXTURE  (M_3D+M_TEXTURE)
#define M_3D_FLAT     (M_3D+M_FLAT)

   int grid_type;
#define GRID_NORMAL   0
#define GRID_NONE     1
#define GRID_SPECIAL  2

} gl_viewport_t;


/* The correct OpenGL context must be current when these are called. */

/* Call when viewport is created */
void S_GL_Init(gl_viewport_t *v);

/* Call when viewport is resized */
void S_GL_Resize(gl_viewport_t *v);

void S_GL_Render(gl_viewport_t *v);


void S_GL_SelectionWindow_DrawBox(int x0,int y0,int x1,int y1);


void S_GL_InitRender(void);
void S_GL_DoneRender(void);


/* Whoever calls us provides this. */
gl_viewport_t *S_GL_vport;

#endif

