#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "../glade_support.h"

#undef TRUE
#undef FALSE

#include "defines.h"
#include "types.h"

#include "s_gui.h"

#include "entclass.h"
#include "entity.h"


static int done;

static GtkWidget *ee;
static GtkCList *list;
static GtkEntry *ekey,*evalue;
static int sel_row;
static GtkText *desc;

static entity_t *e;


static void FillList(void)
{
   int i;
   char *c[2];

   gtk_clist_clear(list);

   gtk_clist_freeze(list);
   for (i=0;i<e->num_keys;i++)
   {
      c[0]=e->key[i];
      c[1]=e->value[i];
      gtk_clist_append(list,c);
   }
   gtk_clist_thaw(list);

   {
      const char *c;
      eclass_t *ec;
      
      gtk_text_freeze(desc);
      gtk_text_backward_delete(desc,gtk_text_get_length(desc));
      if ((c=GetKeyValue(e,"classname")) && (ec=FindClass(c)))
      {
         gtk_text_insert(desc,NULL,NULL,NULL,
            ec->comment,-1);
      }
      else
      {
         gtk_text_insert(desc,NULL,NULL,NULL,
            "No description.",-1);
      }
      gtk_text_thaw(desc);
   }
}


gboolean
ee_delete_win                          (ARG_UNUSED(GtkWidget       *widget),
                                        ARG_UNUSED(GdkEvent        *event),
                                        ARG_UNUSED(gpointer         user_data))
{
   done=0;
   gtk_main_quit();
   return TRUE;
}


void
ee_ok_clicked                          (ARG_UNUSED(GtkButton       *button),
                                        ARG_UNUSED(gpointer         user_data))
{
   done=1;
   gtk_main_quit();
}


void
ee_cancel_clicked                      (ARG_UNUSED(GtkButton       *button),
                                        ARG_UNUSED(gpointer         user_data))
{
   done=0;
   gtk_main_quit();
}


void
ee_add                                 (ARG_UNUSED(GtkButton       *button),
                                        ARG_UNUSED(gpointer         user_data))
{
   char *k,*v;

   k=gtk_entry_get_text(ekey);
   v=gtk_entry_get_text(evalue);
   if (k && v && k[0])
      SetKeyValue(e,k,v);
   FillList();
}

void
ee_update                              (ARG_UNUSED(GtkButton       *button),
                                        ARG_UNUSED(gpointer         user_data))
{
   char *k,*v;

   if (sel_row!=-1)
   {
      gtk_clist_get_text(list,sel_row,0,&k);
      RemoveKeyValue(e,k);
   }
   
   k=gtk_entry_get_text(ekey);
   v=gtk_entry_get_text(evalue);
   if (k && v && k[0])
      SetKeyValue(e,k,v);

   FillList();
}

void
ee_delete                              (ARG_UNUSED(GtkButton       *button),
                                        ARG_UNUSED(gpointer         user_data))
{
   char *k;
   if (sel_row!=-1)
   {
      gtk_clist_get_text(list,sel_row,0,&k);
      RemoveKeyValue(e,k);
      FillList();
   }
}

void
ee_clear                               (ARG_UNUSED(GtkButton       *button),
                                        ARG_UNUSED(gpointer         user_data))
{
   gtk_entry_set_text(ekey,"");
   gtk_entry_set_text(evalue,"");
}


void
ee_keys_select                         (ARG_UNUSED(GtkCList        *clist),
                                        gint             row,
                                        ARG_UNUSED(gint             column),
                                        ARG_UNUSED(GdkEvent        *event),
                                        ARG_UNUSED(gpointer         user_data))
{
   char *c;
   sel_row=row;
   gtk_clist_get_text(list,row,0,&c);
   gtk_entry_set_text(ekey,c);
   gtk_clist_get_text(list,row,1,&c);
   gtk_entry_set_text(evalue,c);
}


void
ee_e_activate                          (ARG_UNUSED(GtkEditable     *editable),
                                        ARG_UNUSED(gpointer         user_data))
{
   gtk_container_focus(GTK_CONTAINER(ee),GTK_DIR_TAB_FORWARD);
}


int S_GUI_EditEntity(entity_t *pe)
{
   ee=create_ee();
   gtk_box_set_homogeneous(GTK_BOX(lookup_widget(ee,"dialog_action_area1")),0);
   list=GTK_CLIST(lookup_widget(ee,"keys"));
   ekey=GTK_ENTRY(lookup_widget(ee,"ekey"));
   evalue=GTK_ENTRY(lookup_widget(ee,"evalue"));
   desc=GTK_TEXT(lookup_widget(ee,"desc"));

   gtk_text_set_word_wrap(desc,TRUE);

   e=pe;
   sel_row=-1;

   FillList();

   gtk_widget_show(ee);
   gtk_main();
   gtk_widget_destroy(ee);

   list=NULL;
   ekey=evalue=NULL;

   e=NULL;
   
   return done;
}

