#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include <gtk/gtk.h>

#include "g_message.h"

#include "g_gui.h"
#include "g_input.h"
#include "g_menu.h"


/* TODO: think of some better way to do this */
#define ARG_UNUSED(x) x __attribute__ ((unused))


static GtkWindow *mwin;
static GtkText *mtext;


static gint mwin_delete(ARG_UNUSED(GtkWidget *w),ARG_UNUSED(GdkEvent *e),ARG_UNUSED(gpointer data))
{
   return TRUE;
}


void S_InitMessages(void)
{
   GtkWidget *tb;
   GtkWidget *vb;

   mwin=GTK_WINDOW(gtk_window_new(GTK_WINDOW_TOPLEVEL));
   gtk_window_set_title(mwin,"Message area");
   gtk_widget_set_usize(GTK_WIDGET(mwin),400,70);
   gtk_window_set_policy(mwin,1,1,0);
   gtk_window_set_transient_for(mwin,S_menu_window);

   gtk_widget_set_events(GTK_WIDGET(mwin),
      GDK_KEY_PRESS_MASK|GDK_KEY_RELEASE_MASK);
   gtk_signal_connect(GTK_OBJECT(mwin),"key_press_event",GTK_SIGNAL_FUNC(S_in_key),NULL);
   gtk_signal_connect(GTK_OBJECT(mwin),"key_release_event",GTK_SIGNAL_FUNC(S_in_key),NULL);
   
   gtk_signal_connect(GTK_OBJECT(mwin),"delete_event",GTK_SIGNAL_FUNC(mwin_delete),NULL);

   mtext=GTK_TEXT(gtk_text_new(NULL,NULL));
   gtk_text_set_word_wrap(mtext,TRUE);

   tb=gtk_table_new(2,1,FALSE);
   gtk_table_attach(GTK_TABLE(tb),GTK_WIDGET(mtext),0,1,0,1,
      GTK_FILL|GTK_EXPAND|GTK_SHRINK,
      GTK_FILL|GTK_EXPAND|GTK_SHRINK,0,0);

   vb=gtk_vscrollbar_new(mtext->vadj);
   gtk_table_attach(GTK_TABLE(tb),vb,1,2,0,1,
      GTK_FILL,GTK_EXPAND|GTK_FILL|GTK_SHRINK,0,0);
   gtk_widget_show(vb);

   gtk_container_add(GTK_CONTAINER(mwin),tb);

   gtk_widget_show(GTK_WIDGET(mtext));
   gtk_widget_show(tb);
   gtk_widget_show(GTK_WIDGET(mwin));
   S_LoadWinPosition(mwin,"messages");
}

void S_DoneMessages(void)
{
   S_SaveWinPosition(mwin,"messages");
}


void S_NewMessage(const char *format, ...)
{
   char buf[1024];
   va_list args;

   va_start(args,format);
   vsnprintf(buf,sizeof(buf)-1,format,args);
   va_end(args);

   gtk_text_freeze(mtext);

   gtk_text_insert(mtext,NULL,NULL,NULL,buf,-1);
   gtk_text_insert(mtext,NULL,NULL,NULL,"\n",-1);

   gtk_text_thaw(mtext);

   gtk_adjustment_set_value(mtext->vadj,mtext->vadj->upper-mtext->vadj->page_size);
}

