#ifndef GTK__G_3D_ALL_H
#define GTK__G_3D_ALL_H


extern GdkColormap *S_colormap;


#include "quest.h" /* necessary for viewport_t definition */
typedef struct
{
   /* Quest-visible fields */
   viewport_t vp;

   /* Fields managed by window handling code */
   int num;
   int sx,sy;
   
   GdkPixmap *pic;
   GtkDrawingArea *da;
   GtkWindow *win;

   /* Fields used by actual renderer */
   matrix_t m;

   /* Different modes of rendering */
   int mode;
#define M_2D_WIRE   0
#define M_3D_WIRE   1

   /* Clip everything beyond a certain distance */
   int depth_clip;
   
   int grid_type;
#define GRID_NORMAL   0
#define GRID_NONE     1
#define GRID_SPECIAL  2
} g_viewport_t;


extern g_viewport_t *S_cur_gvport;


/* Actually render the viewport and fill pic. Doesn't copy it to screen. */
void S_3D_Render(g_viewport_t *v);

void S_3D_Init(g_viewport_t *v);


/* Used in g_int.c, but needs to be in g_3dr.c */
void S_SelectionWindow_DrawBox(int x0,int y0,int x1,int y1);

#endif

