#ifndef MAP_H
#define MAP_H

scalar_t SnapPointToGrid(scalar_t pt);
void SnapVecToGrid(vec3_t *v);

/* if point is almost an int, round it */
scalar_t SnapPointToInt(scalar_t p);
void SnapVecToInt(vec3_t *v);

int VertsAreEqual(vec3_t one, vec3_t two);
int EdgesAreEqual(edge_t one, edge_t two);

void CalcBrushCenter(struct brush_s *b);

void RecalcNormals(struct brush_s *b);
void RecalcAllNormals(void);


void Map_Unload(void);
void Map_New(void);

/* Tries to load/save the map, returns 0 on failure */
int Map_Load(const char *fname);
int Map_Save(void);

int Map_Size(void);

void Map_SetName(const char *name);

/* TODO: think about whether it is guaranteed that all objects that
might end up in the vlists are updated. */
void Map_UpdateVLists(void);
void Map_Update(void);

/* Confirm that the map is to be closed, if it is modified, offer
user chance to save. Doesn't actually change or clear the map. */
int Map_Close(const char *title);

#endif

