#ifndef S_TEXTURE_H
#define S_TEXTURE_H


typedef struct
{
   char name[MAX_TEXTURE_NAME];
   int width,height;
   int cached;
   void *g; /* When freeing textures, this is Q_free:d if it's not NULL */
} texture_t;


extern int S_tex_use_cache;


texture_t *S_T_Load(const char *name);
texture_t *S_T_LoadSize(const char *name);
int S_T_LoadCheck(const char *name);

void S_T_GetDescription(char *dst,const texture_t *t);

int S_T_Cache(const char *name);
int S_T_Uncache(const char *name);


typedef struct
{
   void (*load)(void *tex,const texture_t *t);
   void (*load_size)(void *tex,const texture_t *t);
   void (*tex_desc)(char *dst,const texture_t *t);
} tex_funcs_t;

void S_T_Init(int cache,tex_funcs_t *tf);
void S_T_Clear(void);

void S_T_ClearCache(void);

void S_T_SetPalette(unsigned char *pal);

texture_t *S_T_GetTexture(void *tex);

/* If pal is NULL, use default palette. g is private data for the game. */
void *S_T_AddTexture(const char *name,int width,int height,void *g);

int S_T_AddSize(void *tex,int width,int height);
int S_T_AddData8(void *tex,int width,int height,int data_x,int data_y,unsigned char *data,unsigned char *pal);
int S_T_AddData24(void *tex,int width,int height,int data_x,int data_y,unsigned char *data);

#endif

