#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "qfunc.h"

#include "brush.h"
#include "config.h"
#include "edsel.h"
#include "entity.h"
#include "quest.h"
#include "status.h"
#include "fe/message.h"
#include "fe/gui.h"
#include "fe/render.h"


static void C_edit_grid_inc(void)
{
	Cfg_SetInt(cv_edit_snap_size,cv_edit_snap_size->i*2);
	S_NewMessage("Snap size: %i",cv_edit_snap_size->i);
	S_R_SetUpdate(R_UPDATE_ALL);
}
static func_t F_edit_grid_inc=
{"edit.grid_inc",FUNC_VOID,{fv:C_edit_grid_inc},0,0,0};

static void C_edit_grid_dec(void)
{
	Cfg_SetInt(cv_edit_snap_size,cv_edit_snap_size->i/2);
	if (cv_edit_snap_size->i < 1) Cfg_SetInt(cv_edit_snap_size,1);
	S_NewMessage("Snap size: %i",cv_edit_snap_size->i);
	S_R_SetUpdate(R_UPDATE_ALL);
}
static func_t F_edit_grid_dec=
{"edit.grid_dec",FUNC_VOID,{fv:C_edit_grid_dec},0,0,0};


static void C_edit_delete(void)
{
	bsel_t *b;
	esel_t *e;

	if (!M.sel.bsel && !M.sel.esel)
	{
		S_NewMessage("edit.delete: Nothing selected.");
		return;
	}

	for (b=M.sel.bsel;b;b=b->Next)
	{
		B_Unlink(b->Brush);
		B_Free(b->Brush);
	}
   
	for (e=M.sel.esel;e;e=e->Next)
	{
		if (e->Entity->uid==M.WorldSpawn)
			if (!S_GUI_YesNo("Delete worldspawn?",
			    "Warning: You are about to delete the worldspawn entity. "
			    "Are you REALLY sure you want to do this?"))
				continue;
   
		E_Unlink(e->Entity);
		E_Free(e->Entity);
	}

	ClearSelAll();
	S_R_SetUpdate(R_UPDATE_ALL);
}
static func_t F_edit_delete=
{"edit.delete",FUNC_VOID,{fv:C_edit_delete},0,0,0};


static void C_edit_toggle_texlock(void)
{
	c_texture_locking=!c_texture_locking;
	S_NewMessage("Texture locking %sabled.",
		c_texture_locking?"en":"dis");
}
static func_t F_edit_toggle_texlock=
{"edit.toggle_texlock",FUNC_VOID,{fv:C_edit_toggle_texlock},0,0,0};


static func_t *funcs[]=
{&F_edit_grid_inc,&F_edit_grid_dec,&F_edit_delete,&F_edit_toggle_texlock};

#include "plugin.h"
PLUGIN_HEAD

static plugin_t plugin=
{{Init},{"edit.misc","Misc. fundamental editing commands."}};

PLUGIN_FOOT_FUNCS

