#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <unistd.h>

#include "defines.h"
#include "types.h"

#include "qfunc.h"

#include "error.h"
#include "quest.h"
#include "texdef.h"


static void C_texture_move(qatom_t l)
{
	int dir=QINT(QLIST(&l,0));
	Texdef_MoveSel(&M.sel,dir);
}

static func_t F_texture_move=
{"texture.move",FUNC_VOID,{fva:C_texture_move},NULL,"i",0,
{"Moves the selected texdefs."}
};


static void C_texture_scale(qatom_t l)
{
	int dir=QINT(QLIST(&l,0));
	Texdef_ScaleSel(&M.sel,dir);
}

static func_t F_texture_scale=
{"texture.scale",FUNC_VOID,{fva:C_texture_scale},NULL,"i",0,
{"Scales the selected texdefs."}
};

static func_t *funcs[]={&F_texture_move,&F_texture_scale};


#include "plugin.h"
PLUGIN_HEAD

static plugin_t plugin=
{{Init},{"texture.move","Commands to move and scale textures on faces."}};

PLUGIN_FOOT_FUNCS

