/* Configuration manager */

#include <stdio.h>

#include <gtk/gtk.h>

#include "glade_callbacks.h"
#include "glade_interface.h"
#include "glade_support.h"


static GtkWidget *cm;
static GtkCList *cm_list;
static GtkText *cm_info;


#include "quest/qfunc.h"
#include "quest/ql_config.h"
#include "quest/qplist.h"

static config_t *cur_cfg;


extern void cvar_editor(config_t *cfg); /* TODO */


gboolean cm_delete(GtkWidget *widget,GdkEvent *event,gpointer user_data)
{
	(void)widget,(void)event,(void)user_data;
	gtk_main_quit();
	return TRUE;
}

void cm_done_clicked(GtkButton *button,gpointer user_data)
{
	(void)button,(void)user_data;
	gtk_main_quit();
}

void cm_load_clicked(GtkButton *button,gpointer user_data)
{
	(void)button,(void)user_data;
}

void cm_unload_clicked(GtkButton *button,gpointer user_data)
{
	(void)button,(void)user_data;
}

void cm_configure_clicked(GtkButton *button,gpointer user_data)
{
	(void)button,(void)user_data;
}

void cm_cvar_clicked(GtkButton *button,gpointer user_data)
{
	(void)button,(void)user_data;
	if (cur_cfg) cvar_editor(cur_cfg);
}

void cm_list_select(GtkCList *clist,gint row,gint column,GdkEvent *event,gpointer user_data)
{
	char buf[128];
	const char *c;
	(void)clist,(void)column,(void)event,(void)user_data;
	cur_cfg=gtk_clist_get_row_data(cm_list,row);
	gtk_text_freeze(cm_info);
	gtk_text_backward_delete(cm_info,gtk_text_get_length(cm_info));
	if (cur_cfg)
	{
		snprintf(buf,sizeof(buf),
			"%s - %s\n",
			cur_cfg->name,
			QPL_GetString(&cur_cfg->attributes,"description"));
		gtk_text_insert(cm_info,NULL,NULL,NULL,buf,-1);

/* TODO: this is a bit of a hack, the format of (some) properties will probably
need to change slightly */
		snprintf(buf,sizeof(buf),
			"Active: %s\n",
			cur_cfg->active?"Yes":"No");
		gtk_text_insert(cm_info,NULL,NULL,NULL,buf,-1);

		c=QPL_GetString(&cur_cfg->attributes,"provides");
		if (c)
		{
			snprintf(buf,sizeof(buf),
				"Provides: %s\n",c);
			gtk_text_insert(cm_info,NULL,NULL,NULL,buf,-1);
		}

		c=QPL_GetString(&cur_cfg->attributes,"requires");
		if (c)
		{
			snprintf(buf,sizeof(buf),
				"Requires: %s\n",c);
			gtk_text_insert(cm_info,NULL,NULL,NULL,buf,-1);
		}
	}
	gtk_text_thaw(cm_info);
}


static void fill_list(void)
{
	int i;
	config_t *c;
	char *strs[3];

	gtk_clist_set_selection_mode(cm_list,GTK_SELECTION_BROWSE);

	for (i=0;i<num_configs;i++)
	{
		c=configs[i];
		strs[0]=c->name;
		strs[1]=c->active?"Y":"N";
		strs[2]=QPL_GetString(&c->attributes,"description");
		gtk_clist_set_row_data(
			cm_list,
			gtk_clist_append(cm_list,strs),
			c);
	} /* TODO */
	gtk_clist_sort(cm_list);
	gtk_clist_select_row(cm_list,0,0);
}

static void C_cfg_manager(void)
{
	cm=create_configuration_manager();
	cm_list=GTK_CLIST(lookup_widget(cm,"cm_list"));
	cm_info=GTK_TEXT(lookup_widget(cm,"cm_info"));

	gtk_box_set_homogeneous(GTK_BOX(lookup_widget(cm,"dialog_action_area2")),0);
	gtk_text_set_word_wrap(cm_info,TRUE);

	cur_cfg=NULL;
	fill_list();

	gtk_widget_show(cm);
	gtk_main();
	gtk_widget_destroy(cm);

	cm=NULL;
	cm_list=NULL;
	cur_cfg=NULL;
}
static func_t F_cfg_manager=
{"cfg.manager",FUNC_VOID,{fv:C_cfg_manager},NULL,NULL,0,
};


static func_t *funcs[]=
{&F_cfg_manager};

#include "quest/plugin.h"

PLUGIN_HEAD

static plugin_t plugin=
{{Init},{"cfg.manager","Configuration manager (gtk)."}};

PLUGIN_FOOT_FUNCS

