/* TODO: big cleanup */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "input.h"
#include "quest/fe/input.h"

#include "gl/g_3d.h"

#include "quest/error.h"

#include "gui.h"


/* TODO: think of some better way to do this */
#define ARG_UNUSED(x) x __attribute__ ((unused))


typedef struct
{
   int gdk;   /* GDK's value for the key */
   int quest; /* Quest's value to convert to */
   int mod;   /* Set to 1 if this key can safely be combined with modifiers
                 (creative keymaps might break this, but it's better than
                 nothing. */
} conv_t;

static conv_t conv[]={
{GDK_Escape        ,KEY_ESCAPE   ,1},
{GDK_Return        ,KEY_ENTER    ,1},
{GDK_KP_Enter      ,KEY_ENTER    ,1},
{GDK_space         ,KEY_SPACE    ,1},

{GDK_Tab           ,KEY_TAB      ,1},
{GDK_ISO_Left_Tab  ,KEY_TAB      ,1},

{GDK_Up            ,KEY_UP       ,1},
{GDK_Down          ,KEY_DOWN     ,1},
{GDK_Left          ,KEY_LEFT     ,1},
{GDK_Right         ,KEY_RIGHT    ,1},

{GDK_BackSpace     ,KEY_BACKSPC  },
#if TODO /* TODO: do these properly, will have to fix s_input.h and s_input.c too */
{GDK               ,KEY_COLON    },
{GDK               ,KEY_QUOTE    },
{GDK               ,KEY_TILDE    },
{GDK               ,KEY_PIPE     },
{GDK               ,KEY_COMMA    },
{GDK               ,KEY_PERIOD   },
{GDK               ,KEY_Q_MARK   },
{GDK               ,KEY_LF_BRACK },
{GDK               ,KEY_RT_BRACK },
{GDK               ,KEY_CENTER   },
#endif
{GDK_Insert        ,KEY_INSERT   ,1},
{GDK_Delete        ,KEY_DELETE   ,1},
{GDK_Home          ,KEY_HOME     ,1},
{GDK_End           ,KEY_END      ,1},
{GDK_Page_Up       ,KEY_PAGEUP   ,1},
{GDK_Page_Down     ,KEY_PAGEDOWN ,1},
{GDK_KP_Subtract   ,KEY_MINUS    ,1},
{GDK_KP_Add        ,KEY_PLUS     ,1},
{GDK_plus          ,KEY_PLUS     ,0},
{GDK_minus         ,KEY_MINUS    ,0},

{GDK_A,KEY_A,1},{GDK_a,KEY_A,1},
{GDK_B,KEY_B,1},{GDK_b,KEY_B,1},
{GDK_C,KEY_C,1},{GDK_c,KEY_C,1},
{GDK_D,KEY_D,1},{GDK_d,KEY_D,1},
{GDK_E,KEY_E,1},{GDK_e,KEY_E,1},
{GDK_F,KEY_F,1},{GDK_f,KEY_F,1},
{GDK_G,KEY_G,1},{GDK_g,KEY_G,1},
{GDK_H,KEY_H,1},{GDK_h,KEY_H,1},
{GDK_I,KEY_I,1},{GDK_i,KEY_I,1},
{GDK_J,KEY_J,1},{GDK_j,KEY_J,1},
{GDK_K,KEY_K,1},{GDK_k,KEY_K,1},
{GDK_L,KEY_L,1},{GDK_l,KEY_L,1},
{GDK_M,KEY_M,1},{GDK_m,KEY_M,1},
{GDK_N,KEY_N,1},{GDK_n,KEY_N,1},
{GDK_O,KEY_O,1},{GDK_o,KEY_O,1},
{GDK_P,KEY_P,1},{GDK_p,KEY_P,1},
{GDK_Q,KEY_Q,1},{GDK_q,KEY_Q,1},
{GDK_R,KEY_R,1},{GDK_r,KEY_R,1},
{GDK_S,KEY_S,1},{GDK_s,KEY_S,1},
{GDK_T,KEY_T,1},{GDK_t,KEY_T,1},
{GDK_U,KEY_U,1},{GDK_u,KEY_U,1},
{GDK_V,KEY_V,1},{GDK_v,KEY_V,1},
{GDK_W,KEY_W,1},{GDK_w,KEY_W,1},
{GDK_X,KEY_X,1},{GDK_x,KEY_X,1},
{GDK_Y,KEY_Y,1},{GDK_y,KEY_Y,1},
{GDK_Z,KEY_Z,1},{GDK_z,KEY_Z,1},

{GDK_0,KEY_0,0},{GDK_KP_0,KEY_0,1},
{GDK_1,KEY_1,0},{GDK_KP_1,KEY_1,1},
{GDK_2,KEY_2,0},{GDK_KP_2,KEY_2,1},
{GDK_3,KEY_3,0},{GDK_KP_3,KEY_3,1},
{GDK_4,KEY_4,0},{GDK_KP_4,KEY_4,1},
{GDK_5,KEY_5,0},{GDK_KP_5,KEY_5,1},
{GDK_6,KEY_6,0},{GDK_KP_6,KEY_6,1},
{GDK_7,KEY_7,0},{GDK_KP_7,KEY_7,1},
{GDK_8,KEY_8,0},{GDK_KP_8,KEY_8,1},
{GDK_9,KEY_9,0},{GDK_KP_9,KEY_9,1},

{GDK_F1 ,KEY_F1 ,1},
{GDK_F2 ,KEY_F2 ,1},
{GDK_F3 ,KEY_F3 ,1},
{GDK_F4 ,KEY_F4 ,1},
{GDK_F5 ,KEY_F5 ,1},
{GDK_F6 ,KEY_F6 ,1},
{GDK_F7 ,KEY_F7 ,1},
{GDK_F8 ,KEY_F8 ,1},
{GDK_F9 ,KEY_F9 ,1},
{GDK_F10,KEY_F10,1},
{GDK_F11,KEY_F11,1},
{GDK_F12,KEY_F12,1}
};
static const int num_conv=sizeof(conv)/sizeof(conv[0]);


int S_Input_ConvState(int s)
{
   int i=0;
   if (s&GDK_SHIFT_MASK) i|=KEYM_SHIFT;
   if (s&GDK_MOD1_MASK) i|=KEYM_ALT;
   if (s&GDK_CONTROL_MASK) i|=KEYM_CONTROL;
   return i;
}

int S_Input_ConvKey(int k,int s)
{
   conv_t *c;
   int l,h,m;
   int i;

   if (!num_conv) return KEY_NONE;

   for (l=0,h=num_conv-1;l<h;)
   {
      m=(l+h)/2;
      c=&conv[m];
      if (!(i=k-c->gdk))
		{
         if (c->mod)
            return c->quest|s;
         else
            return c->quest;
		}

      if (i<0) h=m-1; else l=m+1;
   }
   c=&conv[l];
   if (k==c->gdk)
	{
      if (c->mod)
         return c->quest|s;
      else
         return c->quest;
	}

   return KEY_NONE;
}


#define MAX_INPUTS ((KEYM_ALT|KEYM_SHIFT|KEYM_CONTROL|0xff)+1)

#include "quest/qfunc.h"
#include "quest/qsymbol.h"

static func_t *cmd_map[MAX_INPUTS];


static void HandleInput(int input)
{
   if (input>=0 && input<MAX_INPUTS && cmd_map[input])
	{
		Func_RunCmd(cmd_map[input]);
	}
}

#if 0
void S_Key_Bind(const char *key,const char *cmd)
{
   int k;

   k=Key_Parse(key);
   if (!k)
   { /* TODO */
      Warning("S_Key_Bind: Couldn't parse '%s', can't bind key!",key);
      return;
   }
   if (cmd_map[k])
      free(cmd_map[k]);

/*   cmd_map[k]=strdup(cmd);*/
	cmd_map[k]=cmd; /* TODO - !!HACK!! */
	
   if (!cmd_map[k])
   {
      Warning("S_Key_Bind: Out of memory, can't bind '%s' to '%s'!",key,cmd);
   }
}
#endif


int S_process_key,S_process_mouse;

gint S_in_key(ARG_UNUSED(GtkWidget *w),GdkEventKey *e)
{
   int i;

   if (!S_process_key) return FALSE;
   if (e->type!=GDK_KEY_PRESS) return FALSE;
   i=S_Input_ConvKey(e->keyval,S_Input_ConvState(e->state));
   if (i) HandleInput(i);
   return FALSE;
}

gint S_in_mouse(ARG_UNUSED(GtkWidget *w),GdkEventButton *e,int *v)
{
	int i;

	if (!S_process_mouse) return FALSE;
	if (e->type!=GDK_BUTTON_PRESS) return FALSE;
	if (v) S_SetCurViewport(*v);

	i=S_Input_ConvState(e->state);
	switch (e->button)
	{
	case 1: i|=KEY_BUTTON1; break;
	case 3: i|=KEY_BUTTON2; break;
	case 2: i|=KEY_BUTTON3; break;
	case 4: i|=KEY_WHEEL_UP; break;
	case 5: i|=KEY_WHEEL_DOWN; break;
	default: /* shouldn't happen */ i=0; break;
	}
	HandleInput(i);

	return TRUE;
}


static int conv_cmp(const void *a,const void *b)
{
   return ((const conv_t *)a)->gdk - ((const conv_t *)b)->gdk;
}

void S_InitInput(void)
{
   S_process_key=S_process_mouse=1;
   qsort(conv,num_conv,sizeof(conv_t),conv_cmp);
}

void S_DoneInput(void)
{
}



#define MENU_DATA_FIELD "quest-menu"


GtkWindow *S_menu_window;
static GtkMenuBar *menu_bar;

static GtkWidget *menu_current;


static void menu_select(ARG_UNUSED(GtkWidget *w),func_t *f)
{
	Func_RunCmd(f);
}


static gint menu_win_delete(ARG_UNUSED(GtkWidget *w),ARG_UNUSED(GdkEvent *e),ARG_UNUSED(gpointer data))
{ /* TODO: exit? */
   return TRUE;
}

#if 0
static GtkMenuItem *FindItem(GtkMenuShell *ms,const char *name)
{
   GList *ch;

   for (ch=ms->children;ch;ch=ch->next)
   {
      if (GTK_IS_LABEL(GTK_BIN(ch->data)->child))
         if (!strcmp(GTK_LABEL(GTK_BIN(ch->data)->child)->label,name))
            return GTK_MENU_ITEM(ch->data);
   }
   return NULL;
}

static void ClearItem(GtkMenuItem *m)
{
   if (m->submenu)
      gtk_menu_item_remove_submenu(m);
   else
   {
      gpointer d;

      d=gtk_object_get_data(GTK_OBJECT(m),MENU_DATA_FIELD);
      gtk_signal_disconnect_by_func(GTK_OBJECT(m),menu_select,d);
   }
}

struct S_Menu *S_Menu_Submenu(struct S_Menu *rm,const char *name)
{
   GtkMenuItem *mi;
   GtkMenu *m;

   mi=FindItem(GTK_MENU_SHELL(rm),name);
   if (mi && mi->submenu)
      return (struct S_Menu *)mi->submenu;

   if (mi)
   {
      ClearItem(mi);
   }
   else
   {
		mi=GTK_MENU_ITEM(gtk_menu_item_new_with_label(""));
		gtk_label_parse_uline(GTK_LABEL(GTK_BIN(mi)->child),name);

      if (GTK_IS_MENU_BAR(rm))
         gtk_menu_bar_append(GTK_MENU_BAR(rm),GTK_WIDGET(mi));
      else
         gtk_menu_append(GTK_MENU(rm),GTK_WIDGET(mi));
      gtk_widget_show(GTK_WIDGET(mi));
   }
   
   m=GTK_MENU(gtk_menu_new());
   gtk_menu_item_set_submenu(GTK_MENU_ITEM(mi),GTK_WIDGET(m));
   return (struct S_Menu *)m;
}

void S_Menu_AddItem(struct S_Menu *rm,const char *name,const char *cmd,int sep)
{
   GtkMenuItem *mi;

   if (name && (mi=FindItem(GTK_MENU_SHELL(rm),name)))
   {
      ClearItem(mi);
   }
   else
   {
      if (sep&1 || !name)
      {
         GtkWidget *a;
      
         mi=GTK_MENU_ITEM(gtk_menu_item_new());
   
         a=gtk_hseparator_new();
         gtk_container_add(GTK_CONTAINER(mi),a);
         gtk_widget_show(a);
         
         gtk_widget_set(GTK_WIDGET(mi),
            "GtkWidget::sensitive",0,
            NULL);
         
         gtk_widget_show(GTK_WIDGET(mi));
         if (GTK_IS_MENU_BAR(rm))
            gtk_menu_bar_append(GTK_MENU_BAR(rm),GTK_WIDGET(mi));
         else
            gtk_menu_append(GTK_MENU(rm),GTK_WIDGET(mi));
      }
		if (name)
		{
	      mi=GTK_MENU_ITEM(gtk_menu_item_new_with_label(name));
	      if (GTK_IS_MENU_BAR(rm))
	         gtk_menu_bar_append(GTK_MENU_BAR(rm),GTK_WIDGET(mi));
	      else
	         gtk_menu_append(GTK_MENU(rm),GTK_WIDGET(mi));
	      gtk_widget_show(GTK_WIDGET(mi));
		}
      
      if (sep&2)
      {
         GtkWidget *a;
         GtkMenuItem *mi2;
      
         mi2=GTK_MENU_ITEM(gtk_menu_item_new());
   
         a=gtk_hseparator_new();
         gtk_container_add(GTK_CONTAINER(mi2),a);
         gtk_widget_show(a);
         
         gtk_widget_set(GTK_WIDGET(mi2),
            "GtkWidget::sensitive",0,
            NULL);
         
         gtk_widget_show(GTK_WIDGET(mi2));
         if (GTK_IS_MENU_BAR(rm))
            gtk_menu_bar_append(GTK_MENU_BAR(rm),GTK_WIDGET(mi2));
         else
            gtk_menu_append(GTK_MENU(rm),GTK_WIDGET(mi2));
      }
   }
   
   gtk_signal_connect(GTK_OBJECT(mi),"activate",GTK_SIGNAL_FUNC(menu_select),cmd);
   gtk_object_set_data(GTK_OBJECT(mi),MENU_DATA_FIELD,cmd);
}
#endif


static void C_menu_add(qatom_t *ret,qatom_t a)
{
	GtkWidget *rm;
	GtkMenuItem *mi;
	GtkMenu *m;

	if (a.x.l[0].type==QAT_MENU)
		rm=a.x.l[0].x.ptr;
	else
		rm=(GtkWidget *)menu_bar;

	mi=GTK_MENU_ITEM(gtk_menu_item_new_with_label(""));
	gtk_label_parse_uline(GTK_LABEL(GTK_BIN(mi)->child),a.x.l[1].x.string);

	if (GTK_IS_MENU_BAR(rm))
		gtk_menu_bar_append(GTK_MENU_BAR(rm),GTK_WIDGET(mi));
	else
		gtk_menu_append(GTK_MENU(rm),GTK_WIDGET(mi));
	gtk_widget_show(GTK_WIDGET(mi));
   
	m=GTK_MENU(gtk_menu_new());
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(mi),GTK_WIDGET(m));

	ret->type=QAT_MENU;
	ret->x.ptr=m;
}
static func_t F_menu_add=
{"menu.add",FUNC_ATOM,{faa:C_menu_add},NULL,"[nm]c",FUNC_NOT_USER};

static void C_menu_set(qatom_t a)
{
	if (a.x.l[0].type==QAT_MENU)
		menu_current=a.x.l[0].x.ptr;
	else
		menu_current=NULL;
}
static func_t F_menu_set=
{"menu.set",FUNC_VOID,{fva:C_menu_set},NULL,"[nm]",FUNC_NOT_USER};

static void C_menu(qatom_t *ret,qatom_t a)
{
	GtkMenuItem *mi;
	GtkWidget *rm=menu_current;
	if (!rm) Error("menu: called with no current menu!");

	if (a.x.l[0].type==QAT_STRING)
	{
		mi=GTK_MENU_ITEM(gtk_menu_item_new_with_label(""));
		gtk_label_parse_uline(GTK_LABEL(GTK_BIN(mi)->child),a.x.l[0].x.string);
		if (GTK_IS_MENU_BAR(rm))
			gtk_menu_bar_append(GTK_MENU_BAR(rm),GTK_WIDGET(mi));
		else
			gtk_menu_append(GTK_MENU(rm),GTK_WIDGET(mi));
		gtk_widget_show(GTK_WIDGET(mi));
		ret->type=QAT_MENU;
		ret->x.ptr=mi;
	}
	else
	{
		GtkWidget *a;
      
		mi=GTK_MENU_ITEM(gtk_menu_item_new());
   
		a=gtk_hseparator_new();
		gtk_container_add(GTK_CONTAINER(mi),a);
		gtk_widget_show(a);
         
		gtk_widget_set(GTK_WIDGET(mi),
			"GtkWidget::sensitive",0,
			NULL);
         
		gtk_widget_show(GTK_WIDGET(mi));
		if (GTK_IS_MENU_BAR(rm))
			gtk_menu_bar_append(GTK_MENU_BAR(rm),GTK_WIDGET(mi));
		else
			gtk_menu_append(GTK_MENU(rm),GTK_WIDGET(mi));
		*ret=qa_nil;
	}
}
static func_t F_menu=
{"menu",FUNC_ATOM,{faa:C_menu},NULL,"[nc]",FUNC_NOT_USER};

static void C_bind(qatom_t a)
{
	int i;
	func_t *f;
	f=a.x.l[0].x.func;
	for (i=1;i<a.type;i++)
	{
		switch (a.x.l[i].type)
		{
		case QAT_MENU:
			{
				GtkMenuItem *mi=GTK_MENU_ITEM(a.x.l[i].x.ptr);
				gtk_signal_connect(GTK_OBJECT(mi),"activate",GTK_SIGNAL_FUNC(menu_select),f);
				gtk_object_set_data(GTK_OBJECT(mi),MENU_DATA_FIELD,f);
			}
			break;

		case QAT_STRING:
			{
				int k;

				k=Key_Parse(a.x.l[i].x.string);
				if (!k)
				{ /* TODO */
					Warning("bind: Couldn't parse '%s', can't bind key!",a.x.l[i].x.string);
					return;
				}

				cmd_map[k]=f;
			}
			break;

		default:
			Error("bind: argument %i has invalid type",i);
		}
	}
}
static func_t F_bind=
{"bind",FUNC_VOID,{fva:C_bind},NULL,"f[mc]+",FUNC_NOT_USER};

static func_t *funcs[]={&F_menu_add,&F_menu_set,&F_menu,&F_bind};


void S_InitMenu(void)
{
   GtkWidget *mb;

	Func_Register(NULL,funcs,sizeof(funcs));

   S_menu_window=GTK_WINDOW(gtk_window_new(GTK_WINDOW_TOPLEVEL));
   gtk_window_set_title(S_menu_window,"Quest");
   gtk_signal_connect(GTK_OBJECT(S_menu_window),"delete_event",GTK_SIGNAL_FUNC(menu_win_delete),NULL);

   gtk_widget_set_events(GTK_WIDGET(S_menu_window),
      GDK_KEY_PRESS_MASK|GDK_KEY_RELEASE_MASK);
   gtk_signal_connect(GTK_OBJECT(S_menu_window),"key_press_event",GTK_SIGNAL_FUNC(S_in_key),NULL);
   gtk_signal_connect(GTK_OBJECT(S_menu_window),"key_release_event",GTK_SIGNAL_FUNC(S_in_key),NULL);


   mb=gtk_menu_bar_new();
   gtk_container_add(GTK_CONTAINER(S_menu_window),mb);
   gtk_widget_show(mb);

   menu_bar=GTK_MENU_BAR(mb);

   gtk_widget_show(GTK_WIDGET(S_menu_window));
   S_LoadWinPosition(S_menu_window,"menu");
}

void S_DoneMenu(void)
{
	S_SaveWinPosition(S_menu_window,"menu");
}

