#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include <gtk/gtk.h>

#include "toolbar.h"

#include "gui.h"
#include "input.h"
#include "menu.h"


/* TODO: think of some better way to do this */
#define ARG_UNUSED(x) x __attribute__ ((unused))


static GtkWindow *toolbar;
static GtkWidget *tb;


static void toolbar_click(ARG_UNUSED(GtkWidget *b),char *cmd)
{
//   Cmd_Run(cmd); TODO
}


static gint toolbar_delete(ARG_UNUSED(GtkWidget *w),ARG_UNUSED(GdkEvent *e),ARG_UNUSED(gpointer data))
{
   return TRUE;
}


static void NewButton(const char *pic,const char *cmd,int x,int y)
{
   GdkPixmap *p;
   GtkWidget *b,*pm;

   b=gtk_button_new();
   gtk_signal_connect(GTK_OBJECT(b),"clicked",GTK_SIGNAL_FUNC(toolbar_click),cmd);

   p=gdk_pixmap_create_from_xpm(GTK_WIDGET(toolbar)->window,NULL,
      &(gtk_widget_get_style(GTK_WIDGET(toolbar))->bg[GTK_STATE_NORMAL]),
      pic);

#ifndef TARGET_MINGW32 /* TODO */
   pm=gtk_pixmap_new(p,NULL);
   gtk_widget_show(pm);
   gtk_container_add(GTK_CONTAINER(b),pm);
#endif
   
   gtk_widget_show(b);
   gtk_table_attach(GTK_TABLE(tb),b,
      x,x+1,y,y+1,
      0,0,0,0);
}


void S_InitToolbar(void)
{
   toolbar=GTK_WINDOW(gtk_window_new(GTK_WINDOW_TOPLEVEL));
   gtk_window_set_title(toolbar,"Toolbar");
   gtk_signal_connect(GTK_OBJECT(toolbar),"delete_event",GTK_SIGNAL_FUNC(toolbar_delete),NULL);
   gtk_window_set_transient_for(toolbar,S_menu_window);

   gtk_widget_set_events(GTK_WIDGET(toolbar),
      GDK_KEY_PRESS_MASK|GDK_KEY_RELEASE_MASK);
   gtk_signal_connect(GTK_OBJECT(toolbar),"key_press_event",GTK_SIGNAL_FUNC(S_in_key),NULL);
   gtk_signal_connect(GTK_OBJECT(toolbar),"key_release_event",GTK_SIGNAL_FUNC(S_in_key),NULL);
   
   gtk_widget_realize(GTK_WIDGET(toolbar));

   tb=gtk_table_new(5,2,0);

   NewButton("graphics/b_brush.xpm","brush.create.cube",0,0);
   NewButton("graphics/b_tex.xpm","texture_select",1,0);
   NewButton("graphics/b_copy.xpm","edit.copy",2,0);
   
   NewButton("graphics/b_copy.xpm","edit.paste",3,0);
   NewButton("graphics/b_copy.xpm","edit.delete",4,0);
   
   NewButton("graphics/b_t_up.xpm"  ,"cam.look_up",0,1);
   NewButton("graphics/b_t_dn.xpm"  ,"cam.look_down",1,1);
   NewButton("graphics/b_t_left.xpm","cam.turn_left",2,1);
   NewButton("graphics/b_t_rt.xpm"  ,"cam.turn_right",3,1);
      
   gtk_container_add(GTK_CONTAINER(toolbar),tb);
   gtk_widget_show(tb);

   gtk_widget_show(GTK_WIDGET(toolbar));
   S_LoadWinPosition(toolbar,"toolbar");
}

void S_DoneToolbar(void)
{
   S_SaveWinPosition(toolbar,"toolbar");
}

