#include <signal.h>

#include "signals.h"

#include "error.h"

typedef struct
{
	int sig;
	const char *name;
} siglist_t;

/* TODO: for some signals we should probably abort immediately
(SIGABR, SIGINT, SIGQUIT), but for some we should probably try
to continue (SIGHUP, SIGILL, SIGFPE, SIGSEGV, SIGBUS */
static siglist_t siglist[] = {
#ifdef SIGHUP
	{SIGHUP, "SIGHUP"},
#endif
#ifdef SIGINT
	{SIGINT, "SIGINT"},
#endif
#ifdef SIGQUIT
	{SIGQUIT, "SIGQUIT"},
#endif
#ifdef SIGILL
	{SIGILL, "SIGILL"},
#endif
#ifdef SIGABRT
	{SIGABRT, "SIGABRT"},
#endif
#ifdef SIGFPE
	{SIGFPE, "SIGFPE"},
#endif
#ifdef SIGSEGV
	{SIGSEGV, "SIGSEGV"},
#endif
#ifdef SIGTERM
	{SIGTERM, "SIGTERM"},
#endif
#ifdef SIGBUS
	{SIGBUS, "SIGBUS"},
#endif
	{-1, "unknown"}
};

static void signalAbort(int signum)
{
	int i;

/* TODO: figure out a good way to do all this */
/*	int *p;
	for (p = siglist; *p != -1; ++p)
		signal(*p, SIG_DFL);*/
//	signal(signum,signalAbort);

	signal(signum,SIG_DFL);

	for (i=0;siglist[i].sig!=-1;i++)
		if (siglist[i].sig==signum)
			break;

/*	Error("Caught signal %i (%s)! You should restart Quest!",signum,siglist[i].name);*/
	Abort("Caught signal %i (%s)!",signum,siglist[i].name);
	raise(signum);
}

void S_InitSignals(void)
{
	/* Set up various signals to call signalAbort() */
	siglist_t *s;
	for (s = siglist; s->sig != -1; s++)
		signal(s->sig, signalAbort);
}

