/*
memory.h file of the Quest Source Code

Copyright 1997, 1998 Alexander Malmberg
Copyright 1996, Trey Harrison and Chris Carollo

This program is distributed under the GNU General Public License.
See legal.txt for more information.
*/

#ifndef MEMORY_H
#define MEMORY_H

extern int memused;
extern int maxused;
extern int Q_TotalMem;

void InitMemory(unsigned int heapsize);

void CloseMemory(void);

void *Q_malloc(int size);

void *Q_realloc(void *temp, int size);

int Q_free(void *temp);

char *Q_strdup(const char *src);


/* Heaps of fixed-size elements */
/*
(to be used for brushes, entities, groups, and probably faces)
*/

typedef struct
{
	unsigned	int free;
	unsigned	int *f;
	unsigned	char *ptr;
} mem_heap_chunk_t;

typedef struct
{
	unsigned	int esize,csize,ipc;
	int n_chunks;
	mem_heap_chunk_t *c;
} mem_heap_t;

extern mem_heap_t mem_brush,mem_entity,mem_group,mem_face;

void Mem_InitHeap(mem_heap_t *h,unsigned int esize);
void *Mem_Alloc(mem_heap_t *h);
void Mem_Free(mem_heap_t *h,void *ptr);

#endif

