#ifndef PLUGIN_H
#define PLUGIN_H


typedef struct plugin_s
{
   struct
   { /* return 0 if init or shutdown can't be done */
      int (*init)(void);
      int (*done)(void);
   } f;
   struct
   {
      const char *name;
      const char *desc;
   } s;
/* used internally */
   int active;
	struct config_s *cfg;
} plugin_t;


extern plugin_t **plugins;
extern int num_plugins;


void Plugin_Register(plugin_t *p);

plugin_t *Plugin_Lookup(const char *name);

void Plugin_Activate(plugin_t *p,struct config_s *cfg);
void Plugin_Deactivate(struct config_s *cfg);


void Plugin_Init(void);


#define PLUGIN_HEAD \
   static int Init(void);
   
#define PLUGIN_FOOT \
   static void Register(void) __attribute__ ((constructor)); \
   static void Register(void) \
   { \
      Plugin_Register(&plugin); \
   }

#define PLUGIN_FOOT_CMDS \
   static int Init(void) \
   { \
      Cmd_Register(&plugin,cmds,sizeof(cmds)); \
      return 1; \
   } \
   PLUGIN_FOOT


#define PLUGIN_FOOT_FUNCS \
   static int Init(void) \
   { \
      Func_Register(&plugin,funcs,sizeof(funcs)); \
      return 1; \
   } \
   PLUGIN_FOOT


#endif

