#ifndef TRANSFORM_H
#define TRANSFORM_H


void TransformLinear(matrix_t m,sel_t *s);
void TransformMove(vec3_t delta,sel_t *s);


/*
Sets up the orig and disp selections suitable for Trans_Linear() and
Trans_Move() with the selection sel. orig contains all the objects that will
be transformed. disp contains copies of all objects.
*/
int Trans_Setup(const sel_t *sel,sel_t *s);

/*
Frees the stuff allocated by Trans_Setup. If restore is set, restore objects
to their state before Trans_Setup, otherwise they stay the way they were
after the last Trans_{Linear,Move}.
*/
void Trans_Done(sel_t *s,int restore);

/*
Transforms the objects in disp using the matrix m. The orig selection should
contain objects with the original information. disp should be a mirror
selection (like the one from Trans_Setup()), and it will be modified.
*/
void Trans_Linear(matrix_t m,sel_t *s);

void Trans_Move(vec3_t delta,sel_t *s);


void Trans_Center(const sel_t *s,vec3_t *center);

#endif

